import java.io.*;
import java.util.*;
import java.text.*;

public class C
{
    public BufferedReader br;
    public PrintStream ps;

    public String toString()
    {
        return "C";
    }

    public class Player
    {
        public int count, failcount, lastpass;
        public LinkedList<Integer> deck;

        public Player()
        {
            count = 1;
            lastpass = 0;
            deck = new LinkedList<Integer>();
        }

        public String toString()
        {
            return "{Player:count=" + count  + ",lastpass=" + lastpass + ",deck=" + deck + "}";
        }
    };
    
    public void doit() throws Exception
    {
        int i, j, k;
        String tokens[];

        br = new BufferedReader( new FileReader( "C.dat" ) );
        ps = new PrintStream( new FileOutputStream( "C.out" ) );

        int ncases = Integer.parseInt( br.readLine().trim() );
        k=0;

        while( ++k<=ncases )
        {
            tokens = br.readLine().split( "\\s+" );

            int n = Integer.parseInt( tokens[0] );
            Player players[] = new Player[n];
            for( i=0; i<n; i++ )
            {
                players[i] = new Player();
            }

            for( i=1; i<=52; i++ )
            {
                players[0].deck.add( new Integer( tokens[i] )  );
            }

            boolean succeeded = false;
            boolean failed = false;
            int failcount = 0;

            do
            {
                ++failcount;
                for( j=n-1; j>=0; j-- )
                {
                    //System.out.println( "Player " + j + ": " + players[j] );
                    if( players[j].deck.size()>0 )
                    {
                        int topcard = players[j].deck.poll();
                        if( players[j].count==topcard )
                        {
                            players[j].lastpass = topcard;
                            if( j<n-1 )
                            {
                                players[j+1].deck.add( topcard );
                            }
                            failcount = 0;
                        }
                        else
                        {
                            players[j].deck.add( topcard );
                        }
                        players[j].count++;
                        if( players[j].count==14 ) players[j].count = 1;
                    }

                }

                succeeded = true;
                failed = (failcount>100);

                for( j=0; j<n; j++ )
                {
                    if( players[j].deck.size()>0 ) succeeded = false;
                }
            }
            while( !succeeded && !failed );

            ps.print( "Case " + k + ":" );

            if( succeeded )
            {
                for( i=0; i<n; i++ )
                {
                    ps.print( " " + players[i].lastpass );
                }
                ps.println();
            }
            else
            {
                ps.println( " unwinnable" );
            }
        }
    }

    public static void main( String args[] ) throws Exception
    {
        try
        {
            (new C()).doit();
        }
        catch( Exception e )
        {
            e.printStackTrace();
        }
    }
};
