import java.io.*;
import java.util.*;
import java.text.*;

public class E
{
    public BufferedReader br;
    public PrintStream ps;

    public String toString()
    {
        return "E";
    }

    public void dumpsig( int sig[] )
    {
        for( int i=0; i<sig.length; i++ )
        {
            System.out.print( " " + sig[i] );
        }
        System.out.println();
    }

    public void dumpsig( long sig[] )
    {
        for( int i=0; i<sig.length; i++ )
        {
            System.out.print( " " + sig[i] );
        }
        System.out.println();
    }

    public void dumpsig( boolean sig[] )
    {
        for( int i=0; i<sig.length; i++ ) if( sig[i] )
        {
            System.out.print( " " + i );
        }
        System.out.println();
    }

    public int solution[], sofar[], unsolved;
    public long target[], sig[];
    public boolean found, ofinterest[], candidate[];

    public void choose( int level, int last )
    {
        int i, j, k;
        if( !found )
        {
            if( level==0 )
            {
                if( unsolved==0 )
                {
                    found = true;
                    for( i=0; i<=50; i++ )
                    {
                        solution[i] = sofar[i];
                    }
                }
            }
            else
            {
                boolean solvedlast = false;
                for( j=last; j<=50 ; j++ ) if( unsolved==0 || candidate[j] )
                {
                    ++sofar[j];
                    boolean ok = true;
                    for( i=0; i<(1100-j); i++ ) if( sig[i]>0 )
                    {
                        if( target[i+j]==sig[i] )
                        {
                            --unsolved;
                            solvedlast = ( unsolved==0 );
                        }

                        target[i+j] -= sig[i];
                        if( ofinterest[i+j] && target[i+j]<0 )
                        {
                            ok = false;
                        }
                    }

                    if(ok) choose( level-1, solvedlast ? 1 : j );

                    for( i=0; i<(1100-j); i++ ) if( sig[i]>0 )
                    {
                        if( target[i+j]==0 ) ++unsolved;
                        target[i+j] += sig[i];
                    }
                    --sofar[j];
                }
            }
        }
    }
    
    public void doit() throws Exception
    {
        int i, j, k;
        String tokens[];

        br = new BufferedReader( new FileReader( "E.dat" ) );
        //ps = new PrintStream( new FileOutputStream( "E.out" ) );
        ps = System.out;

        target = new long[1100];
        sofar = new int[51];
        solution = new int[51];
        ofinterest = new boolean[1100];
        candidate = new boolean[51];

        for(;;)
        {
            int n = Integer.parseInt( br.readLine().trim() );
            if( n==0 ) break;

            long oldsig[];
            long newsig[] = new long[1100];
            Arrays.fill( newsig, 0 );
            newsig[0] = 1;
            int oldmax = 0, newmax = 0;;

            for( i=0; i<n; i++ )
            {
                oldsig = newsig;
                newsig = new long[1100];
                Arrays.fill( newsig, 0 );

                oldmax = newmax;

                tokens = br.readLine().trim().split( "\\s+" );
                for( j=1; j<tokens.length; j++ )
                {
                    int face = Integer.parseInt( tokens[j] );
                    for( k=0; k<=oldmax; k++ )
                    {
                        newsig[k+face] += oldsig[k];
                    }
                    if( face+oldmax > newmax ) newmax = face+oldmax;
                }
            }

            sig = newsig;

            Arrays.fill( target, 0 );

            tokens = br.readLine().trim().split( "\\s+" );
            int r = Integer.parseInt( tokens[0] );

            unsolved = 0;

            Arrays.fill( ofinterest, false );
            for( k=2; k<tokens.length; k+=2 )
            {
                i = Integer.parseInt( tokens[k] );
                j = Integer.parseInt( tokens[k+1] );

                target[i] = j;
                ofinterest[i] = true;
                if( j>0 ) ++unsolved;
            }

            Arrays.fill( candidate, false );
            for( i=0; i<1100; i++ ) if( ofinterest[i] && target[i]>0 )
            {
                for( j=1; j<=50 && j<i; j++ ) if( sig[i-j]>0 )
                {
                    candidate[j] = true;
                }
            }

            Arrays.fill( solution, 0 );
            Arrays.fill( sofar, 0 );
            found = false;

            choose( r, 1 );

            if( found )
            {
                ps.print( "Final die face values are" );
                for( i=0; i<=50; i++ ) for( j=0; j<solution[i]; j++ ) 
                {
                    ps.print( " " + i );
                }
                ps.println();
            }
            else
            {
                ps.println( "Impossible" );
            }
        }

    }

    public static void main( String args[] ) throws Exception
    {
        try
        {
            (new E()).doit();
        }
        catch( Exception e )
        {
            e.printStackTrace();
        }
    }
};
