import java.io.*;
import java.util.*;
import java.text.*;

public class F
{
    public BufferedReader br;
    public PrintStream ps;

    public String toString()
    {
        return "F";
    }

    public boolean used[];
    public LinkedList<String> controls;
    public char teams[] = "ABCDE".toCharArray();

    public void gencontrols( String control, int level )
    {
        if( level==0 )
        {
            controls.add( control );
        }
        else
        {
            for( int i=0; i<5; i++ ) if( !used[i] )
            {
                used[i] = true;
                gencontrols( control+teams[i], level-1 );
                used[i] = false;
            }
        }
    }

    public int distance( String c, String p )
    {
        int dist = 0;
        while( c.length()>0 )
        {
            int pos = p.indexOf( c.charAt(0) );
            c = c.substring( 1 );
            p = p.substring( 0, pos ) + p.substring( pos+1 );
            dist += pos;
        }

        return dist;
    }
    
    public void doit() throws Exception
    {
        int i, j;
        String tokens[];

        br = new BufferedReader( new FileReader( "F.dat" ) );
        ps = new PrintStream( new FileOutputStream( "F.out" ) );

        controls = new LinkedList<String>();
        used = new boolean[5];
        Arrays.fill( used, false );
        gencontrols( "", 5 );
        Collections.sort( controls );

        for(;;)
        {
            int n = Integer.parseInt( br.readLine().trim() );
            if( n==0 ) break;

            LinkedList<String> polls = new LinkedList<String>();

            for( i=0; i<n; i++ )
            {
                polls.add(  br.readLine().trim() );
            }

            String best = "XXXXX";
            int bestcost = Integer.MAX_VALUE;

            for( String control : controls )
            {
                int cost=0;
                for( String poll : polls )
                {
                    cost += distance( control, poll );
                }

                if( cost<bestcost )
                {
                    bestcost = cost;
                    best = control;
                }
            }

            ps.println( best + " is the median ranking with value " + bestcost + "." );
        }
    }

    public static void main( String args[] ) throws Exception
    {
        try
        {
            (new F()).doit();
        }
        catch( Exception e )
        {
            //e.printStackTrace();
        }
    }
};
